// naumann@stce.rwth-aachen.de

#include<cmath>
#include<iostream>

template<typename T, typename PT>
T f(T &x, const PT &p) {
   return pow(x,2)-p;
}

template<typename T, typename PT>
T dfdx(T &x, const PT &) {
  return 2*x;
}

template<typename T, typename PT>
void newton(T &x, const T &p, const PT &eps, const unsigned int maxit) {
  unsigned int it=0;
  T y=f(x,p);
  do {
    x-=y/dfdx(x,p);
    y=f(x,p);
    if (++it==maxit) break;
  } while(fabs(y)>eps);
}
