// naumann@stce.rwth-aachen.de

#include<cmath>

template<typename T, typename PT>
void newton_t(T &x, T &x_t, const T &p, const T &p_t, const PT &eps, const unsigned int maxit) {
  unsigned int it=0;
  T f_t=2*x*x_t-p_t;
  T f=pow(x,2)-p;
  do {
    T dfdx_t=2*x_t;
    T dfdx=2*x;
    x_t-=f_t/dfdx-f*dfdx_t/pow(dfdx,2);
    x-=f/dfdx;
    f_t=2*x*x_t-p_t;
    f=pow(x,2)-p;
    if (++it==maxit) break;
  } while(fabs(f)>eps);
}
