// naumann@stce.rwth-aachen.de

#include<cmath>

template<typename T, typename PT>
void newton(T &x, const T &p, const PT &eps, const unsigned int maxit) {
  unsigned int it=0;
  T f=pow(x,2)-p;
  do {
    T dfdx=2*x;
    x-=f/dfdx;
    f=pow(x,2)-p;
    if (++it==maxit) break;
  } while(fabs(f)>eps);
}
